<?php

namespace Drupal\harmonize\Plugin\crocheteer\Hook;

use Drupal\Core\Cache\Cache;
use Drupal\harmonize\Constants\HarmonizerTypes;
use Drupal\crocheteer\Plugin\Hook\Entity\HookEntityPresavePlugin;

/**
 * Class HookEntityPresave.
 *
 * Only implement the ContainerFactoryPluginInterface if you need dependency
 * injection mechanisms.
 *
 * @noinspection
 *   AnnotationMissingUseInspection
 *
 * @HookEntityPresave(
 *   id = "harmonizer_entity_presave",
 *   title = @Translation("Harmonizer - Entity Presave Hook"),
 *   entityTypes = {
 *     "node",
 *     "paragraph",
 *   },
 * )
 */
final class HookEntityPresaveNode extends HookEntityPresavePlugin {

  /**
   * {@inheritdoc}
   */
  public function hook() : void {
    // Get the entity being saved.
    $entity = $this->event->getEntity();
    Cache::invalidateTags([HarmonizerTypes::ENTITY . '.' . $entity->getEntityTypeId() . '.' . $entity->bundle() . '.' . $entity->id()]);
  }

}
